/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Datebox;

import com.rjconsultores.ventaboletos.entidad.ProdVigencia;
import com.rjconsultores.ventaboletos.service.ProdVigenciaService;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 *
 * @author Administrador
 */
@Controller("editarProdVigenciaController")
@Scope("prototype")
public class EditarProdVigenciaController extends MyGenericForwardComposer {

    @Autowired
    private ProdVigenciaService prodVigenciaService;
    private MyListbox prodVigenciaList;
    private ProdVigencia prodVigencia;
    private Datebox fecInicio;
    private List<ProdVigencia> lsProdVigencia;
    private Datebox fecFinal;
    private static Logger log = Logger.getLogger(EditarProdTipoptovtaController.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        prodVigencia = (ProdVigencia) Executions.getCurrent().getArg().get("prodVigencia");
        prodVigenciaList = (MyListbox) Executions.getCurrent().getArg().get("prodVigenciaList");
        lsProdVigencia = (List<ProdVigencia>) Executions.getCurrent().getArg().get("lsProdVigencia");
        super.doAfterCompose(comp);

        if (prodVigencia.getProdvigenciaId() != null) {
            fecInicio.setValue(prodVigencia.getFecvigenciainicio());
            fecFinal.setValue(prodVigencia.getFecvigenciafin());
        }
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {

        fecInicio.getValue();
        fecFinal.getValue();

        if (fecInicio.getValue().after(fecFinal.getValue())) {
            Messagebox.show(Labels.getLabel("editarProductoServicioController.MSG.fechaViaje"), Labels.getLabel("editarProdVigenciaController.winEditarProdVigencia.title"), Messagebox.OK, Messagebox.INFORMATION);
        } else {
            try {
                if (prodVigencia.getProductoServicio() == null) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Error.combobox"),
                            Labels.getLabel("editarProdVigenciaController.winEditarProdVigencia.title"),
                            Messagebox.OK, Messagebox.ERROR);
                    return;
                }
                prodVigencia.setFecvigenciainicio(fecInicio.getValue());
                prodVigencia.setFecvigenciafin(fecFinal.getValue());

                List<ProdVigencia> lsVT1 = prodVigenciaService.buscarTraslapa(prodVigencia);


                // checando se a vigencia pode ser salva. A data de inicio de uma
                // nova vigencia tem q ser maior que a da fim da vigencia anterior
                // para que não tenha tarifas com duas vigencias:
                Boolean podeSalvar = lsVT1.isEmpty() ? true : false;
                //Se for ele mesmo pode salvar.
                if (lsVT1.size() == 1) {
                    //Somente edição
                    if (prodVigencia.getProdvigenciaId() != null) {
                        if (prodVigencia.getProdvigenciaId().equals(lsVT1.get(0).getProdvigenciaId())) {
                            podeSalvar = true;
                        }
                    }
                }

                if (podeSalvar) {

                    if (prodVigencia.getProdvigenciaId() != null) {
                        prodVigenciaService.actualizacion(prodVigencia);
                        prodVigenciaList.updateItem(prodVigencia);
                        lsProdVigencia.add(prodVigencia);
                    } else {
                        prodVigenciaService.suscribir(prodVigencia);
                        prodVigenciaList.addItem(prodVigencia);
                        lsProdVigencia.add(prodVigencia);
                    }
                    closeWindow();
                } else {
                    Messagebox.show(
                            Labels.getLabel("editarProdVigenciaController.MSG.registroTraslapado"),
                            Labels.getLabel("editarProdVigenciaController.winEditarProdVigencia.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } catch (Exception ex) {
                log.error(ex);
            }
        }
    }

    /**
     * 
     * @return
     *  0 - Esta ok
     *  1 - Registro duplicado
     *  2 - Registro traslapado
     * @throws InterruptedException 
     */
    private int registroDuplicado() throws InterruptedException {
        List<ProdVigencia> lsProdVigenciaActivo = new ArrayList<ProdVigencia>();

        for (ProdVigencia pv : lsProdVigencia) {
            if (pv.getActivo()) {
                lsProdVigenciaActivo.add(pv);
            }
        }

        Collections.sort(lsProdVigenciaActivo, new Comparator<ProdVigencia>() {

            public int compare(ProdVigencia o1, ProdVigencia o2) {
                return o1.getFecvigenciainicio().compareTo(o2.getFecvigenciainicio());
            }
        });

        for (ProdVigencia pv : lsProdVigenciaActivo) {
//            if (DateUtils.isSameDay(pv.getFecvigenciainicio(), prodVigencia.getFecvigenciainicio())
//                    && DateUtils.isSameDay(pv.getFecvigenciafin(), prodVigencia.getFecvigenciafin())) {
//                return 1;
//            }


            if (DateUtil.intersectDate(pv.getFecvigenciainicio(), pv.getFecvigenciafin(), prodVigencia.getFecvigenciainicio(), prodVigencia.getFecvigenciafin())) {
                return 2;
            }
        }

        return 0;
    }

    public void onClick$btnRemover(Event ev) {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdVigenciaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProdVigenciaController.winEditarProdVigencia.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodVigencia.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodVigencia.setFecmodif(Calendar.getInstance().getTime());
                prodVigencia.setActivo(Boolean.FALSE);

                prodVigenciaList.removeItem(prodVigencia);
                prodVigenciaService.borrar(prodVigencia);

                Messagebox.show(
                        Labels.getLabel("editarProdVigenciaController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProdVigenciaController.winEditarProdVigencia.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    /**
     * @return the lsProdVigencia
     */
    public List<ProdVigencia> getLsProdVigencia() {
        return lsProdVigencia;
    }

    /**
     * @param lsProdVigencia the lsProdVigencia to set
     */
    public void setLsProdVigencia(List<ProdVigencia> lsProdVigencia) {
        this.lsProdVigencia = lsProdVigencia;
    }
}
